#pragma once

#include "CoreMinimal.h"
#include "SourceBasedOutlineUpdateStrategy.h"
#include "UObject/NoExportTypes.h"
#include "GameplayTagContainer.h"
#include "SurvivorOutlineUpdateStrategy.generated.h"

class UTexture;
class AKiller;
class ASurvivor;
class UGameplayModifierContainer;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class DEADBYDAYLIGHT_API USurvivorOutlineUpdateStrategy : public USourceBasedOutlineUpdateStrategy
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FLinearColor _inDangerColorForSurvivor;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	FLinearColor _noRecoveryDyingColor;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	FLinearColor _fullRecoveryDyingColor;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FLinearColor _saviourColorForSurvivor;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FLinearColor _colorForKiller;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FLinearColor _locallyObservedSurvivorColor;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UTexture* _revealedGradient;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UTexture* _nonRevealedGradient;

	UPROPERTY(EditAnywhere)
	TArray<FGameplayTag> _revealToKillerDurationTags;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	float _revealToKillerLingerTimer;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	bool _trappedIconActive;

public:
	UFUNCTION(BlueprintCallable)
	void SetTrappedIconActive(bool value);

	UFUNCTION(BlueprintPure)
	bool IsBlockingAuraReadingFromKiller(const AKiller* killer) const;

	UFUNCTION(BlueprintCallable)
	static bool IsActivelyHidingAuraFromKiller(const ASurvivor* subject, const AKiller* witness);

	UFUNCTION(BlueprintCallable)
	static TArray<UGameplayModifierContainer*> GetEffectsProtectingFromKillerAuraReading(const ASurvivor* subject, const AKiller* killer);

public:
	USurvivorOutlineUpdateStrategy();
};

FORCEINLINE uint32 GetTypeHash(const USurvivorOutlineUpdateStrategy) { return 0; }
